> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Get effectiveness for a private set

> This endpoint returns a bunch of useful information about the historical performance of all validators belonging to a private set. Use this endpoint to retrieve top level metrics on proposer effectiveness, attester effectiveness and overall effectiveness.



## OpenAPI

````yaml get /v1/eth/sets/{set_id}/effectiveness
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v1/eth/sets/{set_id}/effectiveness:
    get:
      tags:
        - Performance
      summary: Get effectiveness for a private set
      description: >-
        This endpoint returns a bunch of useful information about the historical
        performance of all validators belonging to a private set. Use this
        endpoint to retrieve top level metrics on proposer effectiveness,
        attester effectiveness and overall effectiveness.
      operationId: get_set_effectiveness_v1_eth_sets__set_id__effectiveness_get
      parameters:
        - name: set_id
          in: path
          required: true
          schema:
            type: string
            format: uuid4
            title: Set Id
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            description: The number of results returned per page
            default: 10
            title: Limit
          description: The number of results returned per page
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            description: The number of results to skip before starting to return
            default: 0
            title: Offset
          description: The number of results to skip before starting to return
        - name: toDate
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date
              - type: 'null'
            description: End date
            examples:
              - '2023-12-31'
            title: Todate
          description: End date
        - name: fromDate
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date
              - type: 'null'
            description: Start date
            examples:
              - '2023-01-01'
            title: Fromdate
          description: Start date
        - name: fromDay
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: 'null'
            description: Start day
            examples:
              - '791'
            title: Fromday
          description: Start day
        - name: toDay
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: 'null'
            description: End day
            examples:
              - '851'
            title: Today
          description: End day
        - name: utc
          in: query
          required: false
          schema:
            anyOf:
              - type: boolean
              - type: 'null'
            description: Returns results based on UTC days (true) or ETH chain days (false)
            default: false
            title: Utc
          description: Returns results based on UTC days (true) or ETH chain days (false)
        - name: sortBy
          in: query
          required: false
          schema:
            type: string
            description: The filter you want results to be sorted by
            title: Sortby
          description: The filter you want results to be sorted by
        - name: sortOrder
          in: query
          required: false
          schema:
            anyOf:
              - $ref: '#/components/schemas/SortOrderEnum'
              - type: 'null'
            description: The sort order for the results
            default: asc
            title: Sortorder
          description: The sort order for the results
        - name: granularity
          in: query
          required: false
          schema:
            anyOf:
              - $ref: '#/components/schemas/GranularityEnum'
              - type: 'null'
            description: The size of time increments you are looking to query
            default: day
            title: Granularity
          description: The size of time increments you are looking to query
        - name: X-Rated-Network
          in: header
          required: false
          schema:
            $ref: '#/components/schemas/Network'
            default: mainnet
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__42
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    SortOrderEnum:
      type: string
      enum:
        - asc
        - desc
      title: SortOrderEnum
    GranularityEnum:
      type: string
      enum:
        - hour
        - day
        - week
        - month
        - quarter
        - year
        - all
      title: GranularityEnum
    Network:
      type: string
      enum:
        - mainnet
        - hoodi
        - holesky
      title: Network
    api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__42:
      properties:
        previous:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
        pages:
          type: integer
          minimum: 0
          title: Pages
        results:
          items:
            $defs:
              IdType:
                type: string
                enum:
                  - depositAddress
                  - withdrawalAddress
                  - nodeOperator
                  - pool
                  - poolShare
                  - entity
                  - validator
                  - privateSet
                title: IdType
            properties:
              hour:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Hour
              day:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Day
              startDay:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Startday
              endDay:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Endday
              startEpoch:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Startepoch
              endEpoch:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Endepoch
              startDate:
                anyOf:
                  - type: string
                  - type: 'null'
                title: Startdate
              endDate:
                anyOf:
                  - type: string
                  - type: 'null'
                title: Enddate
              date:
                anyOf:
                  - type: string
                  - type: 'null'
                title: Date
              startTimestamp:
                anyOf:
                  - type: string
                    format: date-time
                  - type: 'null'
                title: Starttimestamp
              endTimestamp:
                anyOf:
                  - type: string
                    format: date-time
                  - type: 'null'
                title: Endtimestamp
              startSlot:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Startslot
              endSlot:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Endslot
              id:
                type: string
                title: Id
              idType:
                $ref: '#/components/schemas/IdType'
              validatorCount:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Validatorcount
              avgInclusionDelay:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avginclusiondelay
              avgUptime:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avguptime
              avgCorrectness:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avgcorrectness
              avgProposerEffectiveness:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avgproposereffectiveness
              avgValidatorEffectiveness:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avgvalidatoreffectiveness
              avgAttesterEffectiveness:
                anyOf:
                  - type: number
                    minimum: 0
                  - type: 'null'
                title: Avgattestereffectiveness
              sumEndEpochBalance:
                anyOf:
                  - type: number
                  - type: 'null'
                title: Sumendepochbalance
              sumEndEpochEffectiveBalance:
                anyOf:
                  - type: number
                  - type: 'null'
                title: Sumendepocheffectivebalance
            type: object
            required:
              - id
              - idType
              - validatorCount
              - avgInclusionDelay
              - avgUptime
              - avgCorrectness
              - avgProposerEffectiveness
              - avgValidatorEffectiveness
              - avgAttesterEffectiveness
              - sumEndEpochBalance
              - sumEndEpochEffectiveBalance
            title: PrivateSetEffectiveness
            examples:
              - avgAttesterEffectiveness: 97.9580945527236
                avgCorrectness: 0.9929917401071404
                avgInclusionDelay: 1.0138705386457403
                avgProposerEffectiveness: 99.53271028037379
                avgUptime: 0.9999466390184881
                avgValidatorEffectiveness: 97.96642775943795
                date: '2023-01-01'
                day: 796
                endDate: '2023-01-07'
                endDay: 802
                endEpoch: 63775
                hour: 19056
                startDate: '2023-01-01'
                startDay: 796
                startEpoch: 63744
                sumEpochEndBalance: 320000000000000000000
                sumEpochEndEffectiveBalance: 320000000000000000000
                validatorCount: 16075
          type: array
          title: Results
      type: object
      required:
        - previous
        - next
        - pages
        - results
      title: PaginatedV1PrivateSetEffectiveness
      examples:
        - next: >-
            https://api.rated.network//v1/eth/sets/{set_id}/effectiveness?limit=10&offset=30
          pages: 10
          previous: >-
            https://api.rated.network//v1/eth/sets/{set_id}/effectiveness?limit=10&offset=10
          results:
            - - avgAttesterEffectiveness: 97.9580945527236
                avgCorrectness: 0.9929917401071404
                avgInclusionDelay: 1.0138705386457403
                avgProposerEffectiveness: 99.53271028037379
                avgUptime: 0.9999466390184881
                avgValidatorEffectiveness: 97.96642775943795
                date: '2023-01-01'
                day: 796
                endDate: '2023-01-07'
                endDay: 802
                endEpoch: 63775
                hour: 19056
                startDate: '2023-01-01'
                startDay: 796
                startEpoch: 63744
                sumEpochEndBalance: 320000000000000000000
                sumEpochEndEffectiveBalance: 320000000000000000000
                validatorCount: 16075
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    IdType:
      type: string
      enum:
        - depositAddress
        - withdrawalAddress
        - nodeOperator
        - pool
        - poolShare
        - entity
        - validator
        - privateSet
      title: IdType
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````